#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		pybasever	2.7
%define		debug_package	%{nil}
%define		majorver	%(echo %{version} | cut -d '.' -f1-2)
%define		pytname		%(echo python)
%define		pylibdir	%{_prefix}/lib/%{pytname}%{majorver}
#-----------------------------------------------------------------------------
Name		:	python2
Version		:	2.7.18
Release		:	14.8.0.0%{?dist}
Summary		:	An interpreted, interactive, object-oriented programming language
Group		:	Development/Languages

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Python
URL		:	https://www.python.org/

Source0		:	Python-%{version}.tar.xz
Source1		:	python-%{version}-docs-html.tar.bz2
Patch0		:	Python-%{version}-security_fixes-1.patch


#-----------------------------------------------------------------------------
BuildRequires	:	libffi-devel

Provides	:	/usr/bin/python2

Requires	:	python2-rpm-macros
#-----------------------------------------------------------------------------
%description
Python is an interpreted, interactive, object-oriented programming
language often compared to Tcl, Perl, Scheme or Java. Python includes
modules, classes, exceptions, very high level dynamic data types and
dynamic typing. Python supports interfaces to many system calls and
libraries, as well as to various windowing systems (X11, Motif, Tk,
Mac and MFC).

#-----------------------------------------------------------------------------
%package test
Summary		:	The test modules from the main python package
Group		:	Development/Languages
Requires	:	%{name} = %{version}-%{release}

%description test
The test modules from the main python package: %{name}
These have been removed to save space, as they are never or almost
never used in production.

You might want to install the python-test package if you're developing python
code that uses more than just unittest and/or test_support.py.
#-----------------------------------------------------------------------------
%prep
%setup -q -n Python-%{version}
%patch0 -p1

#-----------------------------------------------------------------------------
#building application
%build

#removing reference to /usr/local/bin/python within
#files to avoid a false dependencies
sed -i							\
  -e 's:^#!./usr/local/bin/python:#!/usr/bin/python2:'	\
  -e 's:^#!/usr/local/bin/python:#!/usr/bin/python2:'	\
	Lib/cgi.py					\
	Tools/pybench/pybench.py			\

sed -i							\
  -e '/2to3/d'						\
  ./setup.py

#Note:
#ensurepip=yes to have easy_install/setuptools within
#python
./configure						\
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-shared					\
	--with-threads					\
	--with-system-expat				\
	--with-system-ffi 				\
	--enable-unicode=ucs4				\
	--with-ensurepip=no				\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

sed -i 									\
  -e '/2to3/d'								\
  setup.py

%{__make}								\
	DESTDIR=%{buildroot}						\
	altinstall

# https://fedoraproject.org/wiki/Changes/Python_means_Python3
%{__ln_s}								\
	./%{pytname}%{pybasever}					\
	%{buildroot}%{_bindir}/%{name}

%{__mv}									\
	%{buildroot}%{_bindir}/idle					\
	%{buildroot}%{_bindir}/idle%{pybasever}
%{__ln_s}								\
	./idle%{pybasever}						\
	%{buildroot}%{_bindir}/idle2

%{__mv}									\
	%{buildroot}%{_bindir}/pydoc					\
	%{buildroot}%{_bindir}/pydoc%{pybasever}
%{__ln_s}								\
	./pydoc%{pybasever}						\
	%{buildroot}%{_bindir}/pydoc2

%{__mv}									\
	%{buildroot}%{_bindir}/smtpd.py					\
	%{buildroot}%{_bindir}/smtpd%{pybasever}.py
%{__ln_s}								\
	./smtpd%{pybasever}.py						\
	%{buildroot}%{_bindir}/smtpd2.py

#install html documentation
install -dm755 %{buildroot}%{_defaultdocdir}/%{name}-%{version}
%{__tar}								\
	--strip-components=1						\
	--no-same-owner							\
	--directory %{buildroot}%{_defaultdocdir}/%{name}-%{version}	\
	-xf								\
	 %{SOURCE1}

%{__rm} -f								\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/.buildinfo


## Fixup permissions for shared libraries from non-standard 555 to standard 755:
find									\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version} 		\
	%{buildroot}%{_libdir}				 		\
	-type f -exec chmod u+w {} \;


#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%doc LICENSE README
%{_bindir}/*
%{_includedir}/*
%{_libdir}/libpython%{majorver}.so*
%{_libdir}/pkgconfig/python-%{majorver}.pc
#{_libdir}/pkgconfig/python.pc
#{_libdir}/pkgconfig/%{name}.pc
%{pylibdir}/*
%{_defaultdocdir}/*/*
%{_mandir}/man1/*.1.gz
%exclude %{pylibdir}/*/test
%exclude %{pylibdir}/test/*
%exclude %{pylibdir}/lib-dynload/_ctypes_test.so

%files test
%{pylibdir}/*/test
%{pylibdir}/test/*
%{pylibdir}/lib-dynload/_ctypes_test.so

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#-----------------------------------------------------------------------------
%changelog
